/*
Natural language processing
Semantics

Parser


Luis
99/12/14
*/

s(Prop) --> sn(Sujeito), sv(Prop), { Prop =.. [_, Sujeito|_] }.

sn(Obj) --> nome(Obj).
sn(Obj) --> det, nome(Obj).
sn(X) --> [quem];[alguem].

sv(Rel) --> v(V), sn(Obj), { Rel =.. [V, X, Obj] }.
sv(Rel) --> vi(V), { Rel =.. [V, X] }.

nome(set) --> [set].
nome(osiris) --> [osiris].
nome(isis) --> [isis].
nome(deus) --> [deus]; [deuses].

v(isa) --> [e];[sao].
v(matou) --> [matou].

vi(morreu) --> [morreu].

det --> [os];[um].

% Sistema Interactivo
talk_talk :-
	repeat,
		read_sentence(Type, Sentence),
		process_sentence(Type, Sentence), !.

read_sentence(Type, Sentence):-
	write('Say something or "exit" to end> '),
	getsentence(Type, Sentence), !.

process_sentence(_, [exit]):- !.
process_sentence(Type, Sentence):-
	one( (
		s(Prop, Sentence, []),
		process_representation(Type, Prop)
	    )
	   ),
	fail.

process_representation(+, Prop):-
	acknowledge(Prop),
	assert(Prop).
process_representation(-, Prop):-
	findall(Prop, Prop, Answers),
	show_answers(Answers).

acknowledge(Prop):-
	write(Prop), write(' accepted.'), nl.

show_answers([A|As]):-
	write(A), nl,
	show_answers(As).
show_answers([]).


